>From 3c89b4019e9744221e19e03b82beb39a9a945e7c Mon Sep 17 00:00:00 2001
From: Roiy <roiy@cs.umanitoba.ca>
Date: Fri, 4 Oct 2013 12:41:37 -0500
Subject: [PATCH 4/9] MED Browsing dialogs

---
 modules/gui/qt4/components/annotations_widget.cpp  | 218 ++++++++++++++
 modules/gui/qt4/components/annotations_widget.hpp  |  57 ++++
 .../gui/qt4/components/events_layers_widget.cpp    | 320 +++++++++++++++++++++
 .../gui/qt4/components/events_layers_widget.hpp    |  66 +++++
 modules/gui/qt4/dialogs_provider.cpp               |  42 +++
 modules/gui/qt4/dialogs_provider.hpp               |   5 +
 modules/gui/qt4/util/annotation_tooltip.cpp        | 169 +++++++++++
 modules/gui/qt4/util/annotation_tooltip.hpp        |  60 ++++
 8 files changed, 937 insertions(+)
 create mode 100644 modules/gui/qt4/components/annotations_widget.cpp
 create mode 100644 modules/gui/qt4/components/annotations_widget.hpp
 create mode 100644 modules/gui/qt4/components/events_layers_widget.cpp
 create mode 100644 modules/gui/qt4/components/events_layers_widget.hpp
 create mode 100644 modules/gui/qt4/util/annotation_tooltip.cpp
 create mode 100644 modules/gui/qt4/util/annotation_tooltip.hpp

diff --git a/modules/gui/qt4/components/annotations_widget.cpp b/modules/gui/qt4/components/annotations_widget.cpp
new file mode 100644
index 0000000..9fe7641
--- /dev/null
+++ b/modules/gui/qt4/components/annotations_widget.cpp
@@ -0,0 +1,218 @@
+/*****************************************************************************
+ * annotations_widget.cpp : Annotations tool
+ ****************************************************************************
+ * Copyright (C) 2006-2007 the VideoLAN team
+ * $Id$
+ *
+ * Author: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#define __STDC_FORMAT_MACROS 1
+#define __STDC_CONSTANT_MACROS 1
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "qt4.hpp"
+#include "components/annotations_widget.hpp"
+#include "components/interface_widgets.hpp"
+
+#include <assert.h>
+#include <vlc_url.h>
+#include <vlc_meta.h>
+
+#include <QList>
+#include <QStringList>
+#include <QGridLayout>
+#include <QLineEdit>
+#include <QLabel>
+#include <QSpinBox>
+#include <QTextEdit>
+
+/************************************************************************
+ * Single panels
+ ************************************************************************/
+
+/**
+ * Annotation Widget
+ * Annotations are displayed here
+ */
+AnnotationsWidget::AnnotationsWidget( QWidget *parent,
+                      intf_thread_t *_p_intf )
+                      : QWidget( parent ), p_intf( _p_intf )
+{
+    QGridLayout *annotationLayout = new QGridLayout( this );
+    annotationLayout->setVerticalSpacing( 0 );
+
+    //QFont smallFont = QApplication::font();
+    //smallFont.setPointSize( smallFont.pointSize() - 1 );
+    //smallFont.setBold( true );
+    
+    annotation_text = new QTextEdit;
+    annotation_text->setReadOnly( true );
+    annotationLayout->addWidget( annotation_text, 1, Qt::AlignCenter );
+
+    //annotationLayout->setColumnStretch( 1, 20 );
+    //annotationLayout->setColumnMinimumWidth ( 1, 80 );
+    //annotationLayout->setRowStretch( line, 10 );
+}
+
+
+void AnnotationsWidget::update( )
+{
+    if ( !isVisible() ) return;
+
+    clear();
+
+    //if (THEDP->isDying())
+    //    return;
+    // Don't update if you are in edit mode
+    //if( b_inEditMode ) return;
+
+    seeksegment_t *segments = NULL;
+
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+
+    if (!p_input)
+        return;
+    
+    if ( input_Control( p_input, INPUT_GET_ANNOTATIONS, &segments, NULL, (int64_t)(-1), -1 )  /* get current selected annotation */
+        != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+    
+    if ( segments )
+    {
+        if ( segments->psz_text )
+        {
+            annotation_text->setText( "Events Layer: " + QString(segments->psz_layerName) + " ("+ QString::number(segments->eventNum) + ") \n---------------------\n" +
+                             QString(segments->psz_text) );
+        }  
+
+        vlc_seeksegment_Delete ( segments );
+    }
+
+    vlc_object_release( p_input );
+
+/*
+    p_input = p_item;
+
+    char *psz_annotation;
+#define UPDATE_ANNOTATION( widget, annotation... ) { \
+    if (p_item->i_events > 0)
+    {
+        if ( *FIND p_item vals w/ gdb
+    }
+    widget->setText( 1, QString::number( (qulonglong)calc ) ); }
+
+    UPDATE_ANNOTATION( annotation_text, (p_item->p_stats->i_read_bytes) );
+
+#define UPDATE_ANNOTATION( annotation, widget ) {                                   \
+    psz_annotation = input_item_Get##annotation( p_item );                          \
+    widget->setText( !EMPTY_STR( psz_annotation ) ? qfu( psz_annotation ) : "" );   \
+    free( psz_annotation ); }
+
+#define UPDATE_META_INT( annotation, widget ) {           \
+    psz_annotation = input_item_Get##annotation( p_item );      \
+    if( !EMPTY_STR( psz_annotation ) )                    \
+        widget->setValue( atoi( psz_annotation ) ); }     \
+    free( psz_annotation );
+
+    psz_annotation = input_item_GetTitleFbName( p_item );
+    if( psz_annotation )
+    {
+        title_text->setText( qfu( psz_annotation ) );
+        free( psz_annotation );
+    }
+    else
+        title_text->setText( "" );
+
+    psz_annotation = input_item_GetURI( p_item );
+    if( !EMPTY_STR( psz_annotation ) )
+         emit uriSet( qfu( psz_annotation ) );
+    free( psz_annotation );
+
+    UPDATE_META( Artist, artist_text );
+    UPDATE_META( Genre, genre_text );
+    UPDATE_META( Copyright, copyright_text );
+    UPDATE_META( Album, collection_text );
+    UPDATE_META( Description, description_text );
+    UPDATE_META( Language, language_text );
+    UPDATE_META( NowPlaying, nowplaying_text );
+    UPDATE_META( Publisher, publisher_text );
+    UPDATE_META( EncodedBy, encodedby_text );
+
+    UPDATE_META( Date, date_text );
+
+    QString trackposition( "%1/%2" );
+    psz_annotation = input_item_GetTrackNum( p_item );
+    trackposition = trackposition.arg( psz_annotation );
+    free( psz_annotation );
+    psz_annotation = input_item_GetTrackTotal( p_item );
+    trackposition = trackposition.arg( psz_annotation );
+    free( psz_annotation );
+    tracknumber_text->setText( trackposition );
+
+//    UPDATE_META( Setting, setting_text );
+//    UPDATE_META_INT( Rating, rating_text );
+
+    psz_annotation = input_item_GetURL( p_item );
+    if( !EMPTY_STR( psz_annotation ) )
+    {
+        QString newURL = qfu(psz_annotation);
+        if( currentURL != newURL )
+        {
+            currentURL = newURL;
+            lblURL->setText( "<a href='" + currentURL + "'>" +
+                             currentURL.remove( QRegExp( ".*://") ) + "</a>" );
+        }
+    }
+    free( psz_annotation );
+#undef UPDATE_META_INT
+#undef UPDATE_META
+
+    // If a artURL is available as a local file, directly display it !
+
+    QString file;
+    char *psz_art = input_item_GetArtURL( p_item );
+    if( psz_art )
+    {
+        char *psz = make_path( psz_art );
+        free( psz_art );
+        file = qfu( psz );
+        free( psz );
+    }
+
+    art_cover->showArtUpdate( file );
+    art_cover->setItem( p_item );
+
+    */
+}
+
+
+/*
+ * Clear all the metadata widgets
+ */
+void AnnotationsWidget::clear()
+{
+    annotation_text->clear();
+}
+
+
diff --git a/modules/gui/qt4/components/annotations_widget.hpp b/modules/gui/qt4/components/annotations_widget.hpp
new file mode 100644
index 0000000..fc11d14
--- /dev/null
+++ b/modules/gui/qt4/components/annotations_widget.hpp
@@ -0,0 +1,57 @@
+/*****************************************************************************
+ * annotations_widget.hpp : Annotations tool
+ ****************************************************************************
+ * Copyright (C) 2006-2007 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef _ANNOTATIONSWIDGET_H_
+#define _ANNOTATIONSWIDGET_H_
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <vlc_common.h>
+#include <vlc_meta.h>
+
+#include <QWidget>
+
+#include <limits.h>
+
+class QTextEdit;
+
+class AnnotationsWidget: public QWidget
+{
+    Q_OBJECT
+public:
+    AnnotationsWidget( QWidget *, struct intf_thread_t * );
+
+
+private:
+    struct intf_thread_t *p_intf;
+
+    QTextEdit *annotation_text;
+
+public slots:
+    void update( );
+    void clear();
+};
+
+#endif
diff --git a/modules/gui/qt4/components/events_layers_widget.cpp b/modules/gui/qt4/components/events_layers_widget.cpp
new file mode 100644
index 0000000..fa0437d
--- /dev/null
+++ b/modules/gui/qt4/components/events_layers_widget.cpp
@@ -0,0 +1,320 @@
+/*****************************************************************************
+ * events_layers_widget.cpp : Events Layers tool
+ ****************************************************************************
+ * Copyright (C) 2006-2007 the VideoLAN team
+ * $Id$
+ *
+ * Author: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#define __STDC_FORMAT_MACROS 1
+#define __STDC_CONSTANT_MACROS 1
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "qt4.hpp"
+#include "components/events_layers_widget.hpp"
+#include "components/interface_widgets.hpp"
+#include "adapters/seeksegments.hpp"
+#include "adapters/seekpoints.hpp"
+#include "util/input_slider.hpp"
+
+#include <assert.h>
+#include <vlc_url.h>
+#include <vlc_meta.h>
+
+#include <QList>
+#include <QGridLayout>
+#include <QWindowsStyle>
+#include <QStyleOptionSlider>
+#include <QStyle>
+#include <QPainter>
+
+/************************************************************************
+ * Single panels
+ ************************************************************************/
+
+/**
+ * Events Layers Widget
+ * Events Layers are displayed here
+ */
+EventsLayersWidget::EventsLayersWidget( QWidget *parent,
+                      intf_thread_t *_p_intf )
+                      : QWidget( parent ), p_intf( _p_intf )
+{
+    EventsLayersLayout = new QGridLayout( this );
+    EventsLayersLayout->setHorizontalSpacing( 0 );
+    EventsLayersLayout->setVerticalSpacing( 0 );
+
+    CONNECT( THEMIM->getIM(), eventsChanged( bool ), this, update( bool ) );
+    update( true );
+}
+
+
+void EventsLayersWidget::update( bool inputExists )
+{
+    clear();
+
+    if ( !inputExists )
+        return;
+        
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    int* pi_layers;
+    int* pi_selected;
+    int** ppi_selected;
+    char*** psz_layerNames;
+    if ( input_Control( p_input, INPUT_GET_LAYER_NAMES, &psz_layerNames, &pi_layers ) != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+
+    if ( input_Control( p_input, INPUT_GET_SELECTED_LAYERS, &ppi_selected, &pi_selected ) != VLC_SUCCESS )
+    {
+        vlc_object_release( p_input );
+        return;
+    }
+    int i,j = 0;
+
+    //iLayers * vertical space;
+    for ( i = 0 ; i < *pi_layers ; i++ )
+    {
+        AddRemLayerButton *addRemButton = new AddRemLayerButton( this, p_intf );
+        static QSizePolicy sizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed );
+        sizePolicy.setHorizontalStretch( 0 );
+        sizePolicy.setVerticalStretch( 0 );
+
+        addRemButton->setSizePolicy( sizePolicy );
+        addRemButton->setFixedSize( QSize( 26, 26 ) );
+        addRemButton->setIconSize( QSize( 20, 20 ) );
+        addRemButton->setFocusPolicy( Qt::NoFocus );
+
+        addRemButton->setToolTip( qtr( N_("Add/Remove Events Layer") ) );
+
+        //connect action to button
+        addRemButton->iLayerId = i;
+        addRemButton->bAdded = false;
+
+        EventsLayersLayout->addWidget( addRemButton, i, 0, Qt::AlignCenter | Qt::AlignTop );
+
+
+        QLabel *layerName = new QLabel( qtr( (*psz_layerNames)[i] ) );
+        QPalette* palette = new QPalette();
+	    palette->setColor( QPalette::WindowText, segmentColors[i%9] );    //Colors repeat after 9
+	    layerName->setPalette( *palette );
+
+        //layerName->setLayout( EventsLayersLayout );
+        EventsLayersLayout->addWidget( layerName, i, 1, Qt::AlignCenter | Qt::AlignTop );
+
+        if ( *pi_selected && (*ppi_selected)[j] == i ) 
+        {
+            addLayerStyle( i );     //Re-applies current selection style
+            addRemButton->bAdded = true;
+
+            if ( j < *pi_selected - 1 )
+                j++;
+        }
+        else
+            removeLayerStyle( i );
+
+
+        MetaSlider *slider = new MetaSlider( Qt::Horizontal, NULL, p_intf, false );
+
+        SeekSegments *events = new SeekSegments( slider, p_intf );    //ROIY - this is adding ALL segments - remove?
+        events->psz_layerName = strdup( (*psz_layerNames)[i] );
+        events->update( false );    /* updates for secondary metasliders */
+        slider->setEvents( events );
+
+        SeekPoints *chapters = new SeekPoints( slider, p_intf );
+        slider->setChapters( chapters );
+
+        int64_t length;
+        input_Control( p_input, INPUT_GET_LENGTH, &length );
+        length = length / CLOCK_FREQ;
+        slider->setPosition( 0, 0, length );
+
+
+        eventLayers.push_back( slider );
+        slider->iEventLayersId = i;
+        
+        CONNECT( slider, sliderDragged( float ),
+                 THEMIM->getIM(), sliderUpdate( float ) );
+
+        //slider->setLayout( EventsLayersLayout );
+        QSizePolicy slSizePolicy( QSizePolicy::Expanding, QSizePolicy::Fixed );
+        slider->setSizePolicy( slSizePolicy );
+        EventsLayersLayout->addWidget( slider, i, 2, Qt::AlignCenter | Qt::AlignTop );
+
+        SegmentsTimeLabel *timeLabel = new SegmentsTimeLabel( p_intf, TimeLabel::Remaining );
+        timeLabel->psz_layerName = strdup( (*psz_layerNames)[i] );
+        EventsLayersLayout->addWidget( timeLabel, i, 3, Qt::AlignCenter | Qt::AlignTop );
+    }
+
+    EventsLayersLayout->setRowStretch( i, 1 );
+    EventsLayersLayout->setColumnStretch( 2, 1 );
+
+    vlc_object_release( p_input );
+}
+
+
+/*
+ * Clear all the events layers widgets
+ */
+void EventsLayersWidget::clear()
+{
+
+    while(!eventLayers.empty())
+    {
+        eventLayers.pop_back();
+    }
+
+    for ( int i = 0; i < EventsLayersLayout->rowCount(); ++i )
+        for ( int j = 0; j < EventsLayersLayout->columnCount(); ++j )
+        {
+            msg_Dbg( p_intf, "clear %d/%d" ,i,j);
+
+            QLayoutItem* item = EventsLayersLayout->itemAtPosition(i, j);
+            if (!item) 
+                continue;
+
+            msg_Dbg( p_intf, "deleted %d/%d" ,i,j);
+            EventsLayersLayout->removeItem(item);
+            delete item->widget();
+        }
+
+    delete EventsLayersLayout;
+    EventsLayersLayout = new QGridLayout( this );
+    EventsLayersLayout->setVerticalSpacing( 0 );
+}
+
+//Add all layers
+void EventsLayersWidget::addAll()
+{
+    if ( !EventsLayersLayout )
+        return;
+
+    msg_Err( p_intf, "roiynav all"); //ROIY REMOVE!
+    for ( int i = 0; i < EventsLayersLayout->rowCount(); ++i )
+    {
+        QLayoutItem* item = EventsLayersLayout->itemAtPosition( i, 0 );   //buttons
+        if (!item) 
+            continue;
+
+        AddRemLayerButton *addRemButton = (AddRemLayerButton*) item->widget();
+        addRemButton->extAddRemoveLayer( true );
+    }
+
+}
+
+//Remove all layers
+void EventsLayersWidget::removeAll()
+{
+    if ( !EventsLayersLayout )
+        return;
+
+    msg_Err( p_intf, "roiynav clear"); //ROIY REMOVE!
+    for ( int i = 0; i < EventsLayersLayout->rowCount(); ++i )
+    {
+        QLayoutItem* item = EventsLayersLayout->itemAtPosition( i, 0 );   //buttons
+        if (!item) 
+            continue;
+
+        AddRemLayerButton *addRemButton = (AddRemLayerButton*) item->widget();
+        addRemButton->extAddRemoveLayer( false );
+    }
+}
+
+void EventsLayersWidget::addLayerStyle( int iLayer )
+{
+    QLayoutItem* item = EventsLayersLayout->itemAtPosition( iLayer, 0 );   //Layer name
+    if (item) 
+    {
+        AddRemLayerButton *addRemButton = ( AddRemLayerButton* ) item->widget();
+        addRemButton->setIcon( QIcon( ":/minus" ) );
+        addRemButton->setStyleSheet( QString( "QPushButton {background-color: green;}" ) );
+    }
+
+    item = EventsLayersLayout->itemAtPosition( iLayer, 1 );   //Layer name
+    if (item) 
+    {
+        QLabel *layerName = (QLabel*) item->widget();
+        msg_Err( p_intf, "roiynav add %s", qtu( layerName->text() )); //ROIY REMOVE!
+        //ROIY remove layerName->setStyleSheet("font: 13pt; border-top-width: 1px; border-top-style: solid; border-top-color: green; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: green;}");
+        layerName->setStyleSheet( "font: 13pt; border-top: 2px solid green; border-bottom: 2px solid green; border-right: 2px solid green; border-left: 2px solid green;" );
+    }
+    /*
+    item = EventsLayersLayout->itemAtPosition( iLayer, 2 );   //Layer slider
+    if (item) 
+    {
+        MetaSlider *slider = (MetaSlider*) item->widget();
+        slider->getStyleSheet( "border-top: 1px solid green; border-bottom: 1px solid green;" );
+        slider->setStyleSheet( "border-top: 1px solid green; border-bottom: 1px solid green;" );
+    }
+
+    item = EventsLayersLayout->itemAtPosition( iLayer, 3 );   //Layer time
+    if (item) 
+    {
+        SegmentsTimeLabel *timeLabel = (SegmentsTimeLabel*) item->widget();
+        timeLabel->setStyleSheet( "border-top: 1px solid green; border-bottom: 1px solid green; border-right: 1px solid green;" );
+    }*/
+}
+
+void EventsLayersWidget::removeLayerStyle( int iLayer )
+{
+    QLayoutItem* item = EventsLayersLayout->itemAtPosition( iLayer, 0 );   //Layer name
+    if (item) 
+    {
+        AddRemLayerButton *addRemButton = ( AddRemLayerButton* ) item->widget();
+        addRemButton->setIcon( QIcon( ":/plus" ) );
+        addRemButton->setStyleSheet( QString( "QPushButton {background-color: red;}" ) );
+    }
+
+    item = EventsLayersLayout->itemAtPosition( iLayer, 1 );   //Layer name
+    if (item) 
+    {
+        QLabel *layerName = (QLabel*) item->widget();
+        msg_Err( p_intf, "roiynav remove %s", qtu( layerName->text() )); //ROIY REMOVE!
+        //ROIY remove layerName->setStyleSheet("font: 13pt; border-top-width: 1px; border-top-style: solid; border-top-color: green; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: green;}");
+        layerName->setStyleSheet( "font: 13pt; "); //border-top: 1px solid red; border-bottom: 1px solid red; border-right: 1px solid red; border-left: 1px solid red;" );
+    }
+    /*
+    item = EventsLayersLayout->itemAtPosition( iLayer, 2 );   //Layer slider
+    if (item) 
+    {
+        MetaSlider *slider = (MetaSlider*) item->widget();
+        slider->setStyleSheet( "border-top: 1px solid red; border-bottom: 1px solid red;" );
+    }
+
+    item = EventsLayersLayout->itemAtPosition( iLayer, 3 );   //Layer time
+    if (item) 
+    {
+        SegmentsTimeLabel *timeLabel = (SegmentsTimeLabel*) item->widget();
+        timeLabel->setStyleSheet( "border-top: 1px solid red; border-bottom: 1px solid red; border-right: 1px solid red;" );
+    } 
+    */
+}
+
+EventsLayersWidget::~EventsLayersWidget()
+{
+    clear(); 
+    delete EventsLayersLayout;
+}
\ No newline at end of file
diff --git a/modules/gui/qt4/components/events_layers_widget.hpp b/modules/gui/qt4/components/events_layers_widget.hpp
new file mode 100644
index 0000000..fddf6d6
--- /dev/null
+++ b/modules/gui/qt4/components/events_layers_widget.hpp
@@ -0,0 +1,66 @@
+/*****************************************************************************
+ * events_layers_widget.hpp : Events Layers tool
+ ****************************************************************************
+ * Copyright (C) 2006-2007 the VideoLAN team
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef _EVENTSLAYERSWIDGET_H_
+#define _EVENTSLAYERSWIDGET_H_
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <vlc_common.h>
+#include <vlc_meta.h>
+#include "components/controller.hpp"
+#include "util/input_slider.hpp"
+
+#include <QWidget>
+
+#include <limits.h>
+#include <vector>
+
+class QTextEdit;
+
+class EventsLayersWidget: public QWidget
+{
+    Q_OBJECT
+public:
+    EventsLayersWidget( QWidget *, struct intf_thread_t * );
+    ~EventsLayersWidget();
+    QGridLayout *EventsLayersLayout;
+    std::vector<MetaSlider*> eventLayers;
+    void addLayerStyle( int iLayer );
+    void removeLayerStyle( int iLayer );
+
+
+private:
+    struct intf_thread_t *p_intf;
+    bool resetLayersState;
+
+public slots:
+    void update(  bool inputExists );
+    void clear();
+    void addAll();
+    void removeAll();
+};
+
+#endif
diff --git a/modules/gui/qt4/dialogs_provider.cpp b/modules/gui/qt4/dialogs_provider.cpp
index 524f476..d0e6618 100644
--- a/modules/gui/qt4/dialogs_provider.cpp
+++ b/modules/gui/qt4/dialogs_provider.cpp
@@ -56,6 +56,11 @@
 #include "dialogs/external.hpp"
 #include "dialogs/epg.hpp"
 #include "dialogs/errors.hpp"
+#include "dialogs/annotations.hpp"
+#include "dialogs/events_layers.hpp"
+#include "dialogs/event_properties.hpp"
+#include "dialogs/edit_event.hpp"
+#include "dialogs/delete_event.hpp"
 
 #include <QEvent>
 #include <QApplication>
@@ -148,6 +153,8 @@ void DialogsProvider::customEvent( QEvent *event )
            bookmarksDialog(); break;
         case INTF_DIALOG_EXTENDED:
            extendedDialog(); break;
+        case INTF_DIALOG_ANNOTATIONS:
+           annotationsDialog(); break;
 #ifdef ENABLE_VLM
         case INTF_DIALOG_VLM:
            vlmDialog(); break;
@@ -203,6 +210,41 @@ void DialogsProvider::extendedDialog()
         extDialog->hide();
 }
 
+void DialogsProvider::annotationsDialog()
+{
+    AnnotationsDialog *anoDialog = AnnotationsDialog::getInstance(p_intf );
+
+    anoDialog->toggleVisible();
+}
+
+void DialogsProvider::eventLayersDialog()
+{
+    EventLayersDialog *layersDialog = EventLayersDialog::getInstance(p_intf );
+
+    layersDialog->toggleVisible();
+}
+
+void DialogsProvider::eventPropertiesDialog()
+{
+    EventPropertiesDialog *eventPropertiesDialog = EventPropertiesDialog::getInstance(p_intf );
+
+    eventPropertiesDialog->toggleVisible();
+}
+
+void DialogsProvider::editEventDialog()
+{
+    EditEventDialog *editEventDialog = EditEventDialog::getInstance(p_intf );
+
+    editEventDialog->toggleVisible();
+}
+
+void DialogsProvider::deleteEventDialog()
+{
+    DeleteEventDialog *deleteEventDialog = DeleteEventDialog::getInstance(p_intf );
+
+    deleteEventDialog->toggleVisible();
+}
+
 void DialogsProvider::synchroDialog()
 {
     ExtendedDialog *extDialog = ExtendedDialog::getInstance(p_intf );
diff --git a/modules/gui/qt4/dialogs_provider.hpp b/modules/gui/qt4/dialogs_provider.hpp
index ef23c4b..2ae7295 100644
--- a/modules/gui/qt4/dialogs_provider.hpp
+++ b/modules/gui/qt4/dialogs_provider.hpp
@@ -123,6 +123,11 @@ public slots:
     void extendedDialog();
     void synchroDialog();
     void messagesDialog();
+    void annotationsDialog();
+    void eventLayersDialog();
+    void eventPropertiesDialog();
+    void editEventDialog();
+    void deleteEventDialog();
 #ifdef ENABLE_VLM
     void vlmDialog();
 #endif
diff --git a/modules/gui/qt4/util/annotation_tooltip.cpp b/modules/gui/qt4/util/annotation_tooltip.cpp
new file mode 100644
index 0000000..0c8b96a
--- /dev/null
+++ b/modules/gui/qt4/util/annotation_tooltip.cpp
@@ -0,0 +1,169 @@
+/*****************************************************************************
+ * Copyright © 2011-2012 VideoLAN
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#include "annotation_tooltip.hpp"
+
+#include <QApplication>
+#include <QPainter>
+#include <QPainterPath>
+#include <QBitmap>
+#include <QFontMetrics>
+#include <QDesktopWidget>
+
+#define TIP_HEIGHT 5
+
+AnnotationTooltip::AnnotationTooltip( QWidget *parent ) :
+    QWidget( parent ), mInitialized( false )
+{
+    setWindowFlags( Qt::Window                  |
+                    Qt::WindowStaysOnTopHint    |
+                    Qt::FramelessWindowHint     |
+                    Qt::X11BypassWindowManagerHint );
+
+    // Tell Qt that it doesn't need to erase the background before
+    // a paintEvent occurs. This should save some CPU cycles.
+    setAttribute( Qt::WA_OpaquePaintEvent );
+
+#if defined( Q_WS_WIN ) || defined( Q_WS_PM )
+    /*
+    - This attribute is required on Windows and OS/2 to avoid focus stealing of other windows.
+    - When set on Linux the AnnotationTooltip appears behind the FSController in fullscreen.
+    */
+    setAttribute( Qt::WA_ShowWithoutActivating );
+#endif
+
+    // Inherit from the system default font size -5
+    mFont = QFont( "Verdana", qMax( qApp->font().pointSize() - 5, 7 ) );
+    mTipX = -1;
+}
+
+void AnnotationTooltip::adjustPosition()
+{
+    // Get the bounding box required to print the text and add some padding
+    QFontMetrics metrics( mFont );
+    QRect textbox = metrics.boundingRect( mDisplayedText );
+    //textbox.adjust( -3, -3, 3, 3 );
+    textbox.moveTo( 0, TIP_HEIGHT );
+
+    // Resize the widget to fit our needs
+    QSize size( textbox.width() + 1, textbox.height() + TIP_HEIGHT + 1 );
+
+    // The desired label position is just below the target
+    QPoint position( mTarget.x() - size.width() / 2,
+        mTarget.y() + size.height() + TIP_HEIGHT / 2 );
+
+    // Keep the tooltip on the same screen if possible
+    QRect screen = QApplication::desktop()->screenGeometry( mTarget );
+    position.setX( qMax( screen.left(), qMin( position.x(),
+        screen.left() + screen.width() - size.width() ) ) );
+    position.setY( qMax( screen.top(), qMin( position.y(),
+        screen.top() + screen.height() - size.height() ) ) );
+
+    move( position );
+
+    int tipX = mTarget.x() - position.x();
+    if( mBox != textbox || mTipX != tipX )
+    {
+        mBox = textbox;
+        mTipX = tipX;
+
+        resize( size );
+        buildPath();
+        setMask( mMask );
+    }
+}
+
+void AnnotationTooltip::buildPath()
+{
+    // Prepare the painter path for future use so
+    // we only have to generate the text at runtime.
+
+    // Draw the text box
+    mPainterPath = QPainterPath();
+    mPainterPath.addRect( mBox );
+
+    // Draw the tip
+    QPolygon polygon;
+    polygon << QPoint( qMax( 0, mTipX - 3 ), TIP_HEIGHT)
+            << QPoint( mTipX, 0)
+            << QPoint( qMin( mTipX + 3, mBox.width() ), TIP_HEIGHT );
+    mPainterPath.addPolygon( polygon );
+
+    // Store the simplified version of the path
+    mPainterPath = mPainterPath.simplified();
+
+    // Create the mask used to erase the background
+    // Note: this is a binary bitmap (black & white)
+    mMask = QBitmap( size() );
+    QPainter painter( &mMask );
+    painter.fillRect( mMask.rect(), Qt::white );
+    painter.setPen( Qt::black );
+    painter.setBrush( Qt::black );
+    painter.drawPath( mPainterPath );
+    painter.end();
+}
+
+void AnnotationTooltip::setTip( const QPoint& target, const QString& layerName, const int& eventId, const QString& text )
+{
+    mInitialized = true;
+    mDisplayedText = layerName;
+    if ( !layerName.isEmpty() )
+        mDisplayedText.append( " (" + QString::number(eventId) + ")");
+
+    if (!text.isEmpty())
+        mDisplayedText.append(": " + text );
+
+    if( mTarget != target || layerName != mLayerName || mText != text )
+    {
+        mTarget = target;
+        mLayerName = layerName;
+        mText = text;
+        adjustPosition();
+    }
+
+    update();
+}
+
+void AnnotationTooltip::show()
+{
+    QWidget::setVisible( mInitialized );
+#ifdef Q_WS_PM
+    // Bring a tooltip on the top
+    // Without this, tooltip does not appear on fullscreen
+    // from the second fullscreen state change
+    if( mInitialized )
+        QWidget::raise();
+#endif
+}
+
+void AnnotationTooltip::paintEvent( QPaintEvent * )
+{
+    QPainter p( this );
+    p.setRenderHints( QPainter::HighQualityAntialiasing | QPainter::TextAntialiasing );
+
+    p.setPen( Qt::black );
+    p.setBrush( qApp->palette().base() );
+    p.drawPath( mPainterPath );
+
+    p.setFont( mFont );
+    p.setPen( QPen( qApp->palette().text(), 1 ) );
+    p.drawText( mBox, 0x0024 , mDisplayedText );    //0x0024 = Qt::AlignTop + Qt::AlignHCenter
+}
diff --git a/modules/gui/qt4/util/annotation_tooltip.hpp b/modules/gui/qt4/util/annotation_tooltip.hpp
new file mode 100644
index 0000000..e64dbfa
--- /dev/null
+++ b/modules/gui/qt4/util/annotation_tooltip.hpp
@@ -0,0 +1,60 @@
+/*****************************************************************************
+ * Copyright © 2011 VideoLAN
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef ANNOTATION_TOOLTIP_H
+#define ANNOTATION_TOOLTIP_H
+
+#include <QWidget>
+#include <QBitmap>
+
+class QPaintEvent;
+class QString;
+class QFont;
+class QRect;
+class QPainterPath;
+
+class AnnotationTooltip : public QWidget
+{
+    Q_OBJECT
+public:
+    explicit AnnotationTooltip( QWidget *parent = 0 );
+    void setTip( const QPoint& target, const QString& layerName, const int& eventId, const QString& text );
+    virtual void show();
+
+protected:
+    virtual void paintEvent( QPaintEvent * );
+
+private:
+    void adjustPosition();
+    void buildPath();
+    QPoint mTarget;
+    QString mLayerName;
+    QString mText;
+    QString mDisplayedText;
+    QFont mFont;
+    QRect mBox;
+    QPainterPath mPainterPath;
+    QBitmap mMask;
+    int mTipX;
+    bool mInitialized;
+};
+
+#endif // ANNOTATION_TOOLTIP_H
-- 
1.8.3.msysgit.0

